"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.emit = void 0;
const ArrayUtils = require("../utils/array_utils");
const Keywords = require("./keywords");
const Delimiters = require("./delimiters");
const MethodArgumentTokens = require("./method_argument_tokens");
function emit(statement) {
    if (statement == null)
        return ArrayUtils.empty();
    switch (statement.kind) {
        case "this": return emitInvokeThisConstructor(statement);
        case "base": return emitInvokeBaseConstructor(statement);
        default: throw new Error(`Unknown invoke constructor statement ${statement}`);
    }
}
exports.emit = emit;
function emitInvokeThisConstructor(statement) {
    return [
        Delimiters.space, Delimiters.colon, Delimiters.space,
        Keywords._this, ...MethodArgumentTokens.emit(statement.arguments)
    ];
}
function emitInvokeBaseConstructor(statement) {
    return [
        Delimiters.space, Delimiters.colon, Delimiters.space,
        Keywords.base, ...MethodArgumentTokens.emit(statement.arguments)
    ];
}
