"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.emit = void 0;
const utils_1 = require("../utils");
const Delimiters = require("./delimiters");
/**
 * Emits tokens for a given namespace path using the dot separator.
 * @param path The given namespace path to tokenize.
 * @param isEndDot Emits or not the dot token at the end.
 * @returns An array of tokens for the given namespace path.
 */
function emit(path, isEndDot) {
    if (typeof path === "undefined") {
        return [];
    }
    else {
        const projector = pickProjector(isEndDot);
        return normalizePath(path).flatMap(projector);
    }
}
exports.emit = emit;
function normalizePath(path) {
    return typeof path === "string" ? [path] : path;
}
function pickProjector(isEndDot) {
    if (isEndDot)
        return (x) => [x, Delimiters.dot];
    else
        return (x, i, arr) => utils_1.ArrayUtils.isLastIndex(arr, i) ? x : [x, Delimiters.dot];
}
